DROP TRIGGER BLOQUEIA_DUPLICA_ENTRMERC
/

CREATE OR REPLACE TRIGGER USR_BLOQ_DUPLICA_ENTRMERC
BEFORE INSERT ON USR_ITEM_ENTR_MERC FOR EACH ROW 
DECLARE
    PRAGMA AUTONOMOUS_TRANSACTION;
    V_COUNT             NUMBER;
    V_MAXLANCTOUSR_OLD  VARCHAR2(20);
    V_VRQUANTIDADE_OLD  NUMBER; 
    V_VRUNITARIO_OLD    NUMBER;
    V_CDPRODINTE_OLD    VARCHAR2(20);
    V_CDSERIE           VARCHAR2(5);
    V_NRINSJURFORN      VARCHAR2(20);
    V_CDCODOC           VARCHAR2(20);
BEGIN
    V_COUNT := 0;
    
    BEGIN
        SELECT CDCODOC, CDSERIE, NRINSJURFORN 
        INTO V_CDCODOC, V_CDSERIE, V_NRINSJURFORN
        FROM USR_ENTR_MERC U
        WHERE CDFILIAL = :NEW.CDFILIAL
        AND NRLANCTOUSR = :NEW.NRLANCTOUSR
        AND CDCODOC IS NOT NULL
        FETCH FIRST ROW ONLY;
        
        SELECT COUNT(*) 
        INTO V_COUNT
        FROM USR_ENTR_MERC
        WHERE CDCODOC = V_CDCODOC
        AND   CDSERIE = V_CDSERIE
        AND   NRINSJURFORN = V_NRINSJURFORN
        AND   DTINCLUSAO >= (SYSDATE - INTERVAL '1' DAY);
        
        
    EXCEPTION
    WHEN NO_DATA_FOUND THEN
        V_COUNT := 0;
        V_CDCODOC := NULL;
        V_CDSERIE := NULL;
        V_NRINSJURFORN := NULL;
    END;
    
    IF V_COUNT > 1 THEN
        SELECT MAX(U.NRLANCTOUSR) 
        INTO V_MAXLANCTOUSR_OLD  -- PEGA O PENULTIMO LANAMENTO DE MESMA CHAVE UNICA
        FROM USR_ITEM_ENTR_MERC I, USR_ENTR_MERC U
        WHERE I.CDFILIAL = U.CDFILIAL
        AND I.NRLANCTOUSR = U.NRLANCTOUSR
        AND U.CDCODOC = V_CDCODOC
        AND U.CDSERIE = V_CDSERIE
        AND U.NRINSJURFORN = V_NRINSJURFORN
        AND U.NRLANCTOUSR <> :NEW.NRLANCTOUSR;
        
        SELECT VRQUANTIDADE, VRUNITARIO, CDPRODINTE -- PEGA OS VALORES DO PENULTIMO LANAMENTO
        INTO   V_VRQUANTIDADE_OLD, V_VRUNITARIO_OLD, V_CDPRODINTE_OLD
        FROM USR_ITEM_ENTR_MERC
        WHERE CDFILIAL    = :NEW.CDFILIAL
        AND   NRLANCTOUSR = V_MAXLANCTOUSR_OLD
        AND   CDPRODINTE = :NEW.CDPRODINTE
        FETCH FIRST ROW ONLY;

        IF V_VRQUANTIDADE_OLD = :NEW.VRQUANTIDADE AND V_VRUNITARIO_OLD = :NEW.VRUNITARIO AND V_CDPRODINTE_OLD = :NEW.CDPRODINTE THEN
            DELETE USR_ENTR_MERC
            WHERE CDFILIAL = :NEW.CDFILIAL
            AND NRLANCTOUSR = :NEW.NRLANCTOUSR;
            
            DELETE USR_ITEM_ENTR_MERC
            WHERE CDFILIAL = :NEW.CDFILIAL
            AND NRLANCTOUSR = :NEW.NRLANCTOUSR;
            
            COMMIT;
            RAISE_APPLICATION_ERROR(-20501, 'DOCUMENTO DUPLICADO, MESMAS INFORMACOES DO ULTIMO ENVIO', TRUE);
        END IF;
    END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_BLOQ_DUPLICA_ENTRMERC','6.49.087'); END;
/
